static char *rcsid = "$Id: aerostat.cpp,v 1.4 2007/05/20 13:06:06 cvs Exp $";

#include "stdafx.h"
#include <windows.h>
#include <tchar.h>
#include "aaeroint.h"
#include "aerosubc.h"
#include "aeroglss.h"
#include "GdiplusH.h"
using namespace Gdiplus;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static LRESULT CALLBACK TabControlProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    PAERO_SUBCLASS_WND_DATA pWndData = (PAERO_SUBCLASS_WND_DATA)GetProp(hWnd, WINDOW_DATA_STRING);
    ASSERT(pWndData);
    ASSERT(pWndData->m_pDwmApiImpl);
    WNDPROC pOldProc = pWndData->m_oldWndProc;
    ASSERT(pOldProc);
    PAERO_SUBCLASS_WND_DATA pWndDataParent = (PAERO_SUBCLASS_WND_DATA)GetProp(GetParent(hWnd), WINDOW_DATA_STRING);

    /// 
    /// if aero glass is turned off and if we are not in destruction code, 
    /// just call the original wnd proc we had prior to subclassing:
    /// 
    if(WM_DESTROY!=uMsg && WM_NCDESTROY!=uMsg && pWndDataParent && !pWndData->m_pDwmApiImpl->IsDwmCompositionEnabled())
        return CallWindowProc(pOldProc, hWnd, uMsg, wParam, lParam);

    switch(uMsg)
    {
        case WM_PAINT:
            {
                PAINTSTRUCT ps;
                HDC hdc = BeginPaint(hWnd, &ps);

                if(hdc)
                {
                    HDC hdcPaint = NULL;
                    RECT rcClient;
                    VERIFY(GetClientRect(hWnd, &rcClient));
                
                    LONG_PTR dwStyle = GetWindowLongPtr(hWnd, GWL_STYLE);
                    LONG_PTR dwStyleEx = GetWindowLongPtr(hWnd, GWL_EXSTYLE);
                
                    HTHEME hTheme = pWndData->m_pUxTheme->OpenThemeData(NULL, L"Tab"); 
                
                
                    if(hTheme)
                    {
                        
                        HPAINTBUFFER hBufferedPaint = pWndData->m_pUxTheme->BeginBufferedPaint(hdc, &rcClient, BPBF_TOPDOWNDIB, NULL, &hdcPaint);
                        if (hdcPaint)
                        {
                            VERIFY(PatBlt(hdcPaint, 0, 0, RECTWIDTH(rcClient), RECTHEIGHT(rcClient), BLACKNESS));
                            VERIFY(S_OK==pWndData->m_pUxTheme->BufferedPaintSetAlpha(hBufferedPaint, &ps.rcPaint, 0x00));
                            VERIFY(S_OK==pWndData->m_pUxTheme->EndBufferedPaint(hBufferedPaint, TRUE));
                        }                
                
                        VERIFY(S_OK==pWndData->m_pUxTheme->CloseThemeData(hTheme));
                    }
                }                
                EndPaint(hWnd, &ps);
            }
            break;
        case WM_NCDESTROY:
        case WM_DESTROY:
            VERIFY(UnsubclassControl(hWnd, TabControlProc, pWndData));
            break;
    }
    
    LRESULT lRet = CallWindowProc(pOldProc, hWnd, uMsg, wParam, lParam);

    return lRet;
}

#define TAB_CLASSNAME _T("Tab")

BOOL CALLBACK SubclassTabCtrls(
  HWND hwnd,      // handle to child window
  LPARAM lParam   // application-defined value
)
{
    PBOOL pbSuccess = (PBOOL)lParam;
    ASSERT(pbSuccess);
    
    TCHAR szWndClassName[dimof(TAB_CLASSNAME)];
    if(GetClassName(hwnd, szWndClassName, dimof(szWndClassName)))
    {
        if  (!_tcscmp(szWndClassName, TAB_CLASSNAME))
            *pbSuccess = AeroSubClassTabControl(hwnd);
    }

    return TRUE;
}


BOOL AeroSubClassTabControl(HWND hwnd)
{
    BOOL bSuccess = FALSE;
    bSuccess = AeroSubClassControl(hwnd, TabControlProc, WD_IN_PAINT_CONTROL);
//    if(bSuccess)
//        EnumChildWindows(hwnd, SubclassTabCtrls, (LPARAM)&bSuccess);
    return bSuccess;
}
