#ifndef SETTINGSDIALOG_H
#define SETTINGSDIALOG_H
#include "TreePropSheet.h"
#include "clock.h"

/////////////////////////////////////////////////////////////////////////////
// CStaticCtrl control

class CStaticCtrl : public CStatic
{
	// Construction
public:
	CStaticCtrl();

	// Implementation
public:
	virtual ~CStaticCtrl();

	void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
};

#include "SettingsDialogMisc.h"
#include "SettingsDialogImagesQueued.h"
#include "SettingsDialogQueueImages.h"

/////////////////////////////////////////////////////////////////////////////
// CSettingsDialog dialog

class CSettingsDialog : public CDialog
{
	DECLARE_DYNAMIC(CSettingsDialog)
	// Construction
public:
	CSettingsDialog();   // standard constructor
	~CSettingsDialog();
	virtual BOOL DestroyWindow();
	CButton m_btnApply;			/* Apply button. */
	RECT rcLastSize;

	enum
	{
		IDD = IDD_SETTINGS
	};

	CButton m_BtnOk;
	CButton m_BtnCancel;
	CClock* clock;

	TreePropSheet::CTreePropSheet m_TabSetting;
	CSettingsDialogMisc m_SettingsDialogMisc;
	CSettingsDialogImagesQueued m_SettingsDialogImagesQueued;
	CSettingsDialogQueueImages m_SettingsDialogQueueImages;
	HMODULE hAOT;
	void translate();

protected:
	virtual void DoDataExchange(CDataExchange* pDX);  // DDX/DDV support
	// Implementation
protected:
    afx_msg void OnOK();
    afx_msg void OnCancel();
	afx_msg LRESULT OnNotifyIconMsg(WPARAM wParam, LONG lParam);
	afx_msg void OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnTimer(UINT nIDEvent);
	virtual BOOL OnInitDialog();
	afx_msg void OnBnClickedApply();
	afx_msg void OnSetToNextImage();
	DECLARE_MESSAGE_MAP()
	void OnShowConfigWindow();
	afx_msg LRESULT OnHideMainWindow(WPARAM wParam, LONG lParam);
	void OnExit();
	afx_msg void OnPopupMenuAbout();
	void ApplyChanges(BOOL bChangeWallpaper = TRUE);
	void ResetMainDialog();

	UINT uiTimer;
	NOTIFYICONDATA niData;
};
#endif

extern CSettingsDialog* SettingsDialog;